<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="TraceReport">
<html><title>XML :::: <xsl:value-of select="Navigate/@fileName"/></title><head>

<style>
<!-- Styles for common tags -->
body {
    font-family: Courier New, Lucida Console;
    font-size: 10pt;
}
pre {
    font-size: 10pt;
    color: black;
    margin-top: 0px;
    margin-bottom: 0px;
}

td pre
{
    font-size: 10pt;
}

input.CallDark, input.MessageDark {

    background: #E2E5FF;
    color: black;

    font-size: 7pt;
    font-family: Lucida Console, Courier New;
    border-color: silver;
    border-style: solid;
    border-width: 1px;
    cursor:hand;
    cursor:pointer;
    text-align: Center;
    vertical-align: Center;
   <!-- width: 11px;-->
    height:13px;
    margin: 2px 2px 2px 2px;
    PADDING: 0px 0px 0px 0px;
}


input.CallLight, input.MessageLight {

    background: #FFFFFF;
    color: black;

    font-size: 6.5pt;
    font-family: Lucida Console, Courier New;
    border-color: silver;
    border-style: solid;
    border-width: 1px;
    cursor:hand;
    cursor:pointer;
    text-align: center;
    vertical-align: center;
   <!-- width: 11px;-->
    height:13px;
    margin: 2px 2px 2px 2px;
    PADDING: 0px 0px 0px 0px;
<!--    LINE-HEIGHT: 0pt;-->
}


input.inputNorm {
    font: 10pt "Courier New";
    color: black;
    width:90px;
    height:23px;
}

 ul { list-style-type: none; }

li.MessageDark {
    background: #F2F5FF;
    cursor: pointer;
    cursor: hand;
}


li.MessageLight {
    background: #FFFFFF;
    cursor: pointer;
    cursor: hand;
}


li.oParent {border-top-width: 0px; background: #FFFFFF;}
li {border: 1px solid #E7E7E7;}

li ul li {border-bottom-width: 0px;}



li.cItem {
    color: white;
    cursor: text;
}
li.cItemDark {
    background: #F2F5FF;
    color: white;
    cursor: text;
}

li.oParent {
    color: white;
    cursor: hand;
    cursor: pointer;
}

ul ul {
   display: none;
}

table {
        background: silver;
}

table.Layer {
        border-width: 1px;
}
td {
    font-size: 10pt;
    color: black;
}


td.Light{
   background: #E2E5FF;
   text-align: Center;
   border-bottom-width: 1px;
   border-bottom-color: silver;
   border-bottom-style: solid;
   border-left-width: 1px;
   border-left-color: silver;
   border-left-style: solid;
}



td.Name {
   background:#F0F0FF;
   vertical-align: Top;
   border-bottom-width: 1px;
   border-bottom-color: silver;
   border-bottom-style: solid;
   border-left-width: 1px;
   border-left-color: silver;
   border-left-style: solid;
   border-right-width: 1px;
   border-right-color: silver;
   border-right-style: solid;
   text-indent: 2px;
}



td.Value {
   background:#F0F0FF;
   border-bottom-width: 1px;
   border-bottom-color: silver;
   border-bottom-style: solid;
   border-right-width: 1px;
   border-right-color: silver;
   border-right-style: solid;
   text-indent: 3px;
}

td.LayerInput {
   background:#ffffff;
   border-width: 0px;

   border-bottom-width: 1px;
   border-bottom-color: #E7E7E7;
   border-bottom-style: solid;<!--  11111111111111  -->
   border-left-width: 1px;
   border-left-color: silver;
   border-left-style: solid;
}

th {
    background: #E0E0E0;
    font-size: 10pt;
    color: #575757;
}

.CallStart {
        color: #FF00FF;
        margin-left: 60px;
}

.CallStop {
        color: #FF00FF;
        margin-left: 60px;
}

<!-- Message header colors-->
.NoteRx1, .NoteRx2, .NoteTx1, .NoteTx2,
.AlarmRx1, .AlarmRx2, .AlarmTx1, .AlarmTx2      { color: red;     }
.MsgHdrRx1, .MsgHdrTx1, .MsgIPRx1, .MsgIPTx1,
.ABCDRx1, .ABCDTx1, .LineSignRx1, .LineSignTx1  { color: #0000FF; }
.MsgHdrRx2, .MsgHdrTx2, .MsgIPRx2, .MsgIPTx2,
.ABCDRx2, .ABCDTx2, .LineSignRx2, .LineSignTx2  { color: #00C000; }
.RSRx1, .RSTx1 { color: #C080FF; }
.RSRx2, .RSTx2 { color: #C0E000; }
.PathConf { color: #00C0C0; }

<!-- Backgrounds ******* -->
.Call {
    color: #FF00FF;
}
.Layer {
    color:  #700080;
    cursor: pointer;
    cursor: hand;
    text-decoration: none;
}

.Item
{
    color: #700080;
    text-align: Left;
    cursor: pointer;
    cursor: hand;
    text-decoration: none;
}
.Over {
    cursor: pointer;
    cursor: hand;
    text-decoration: underline;
}

.MsgBody {
}
li.MsgBody {
    color: #FFFFFF;
    cursor: pointer;
    cursor: hand;
}

.MsgHex {
    color: #444444;
    background: #EBEBEB;
}

</style>
<script language="JavaScript" type="text/javascript">
<![CDATA[
        function PrintPageNum (num) {
            var s1="";
            if (num != 1) {
                s1=s1+"_";
                if (num < 10)
                    s1=s1+"00";
                else {
                      if (num < 100)
                          s1=s1+"0";
                }
                s1=s1+num;
            }
            return s1;
        }

        function Links ( fileName, page, pageCount ) {
            if (fileName != "") {
                 var st = "";
                 var d = parseInt(page/10)*10 + 1;
                 if (d != 1) {
                     st = st+"<a href='"+fileName+".xml'>"+"1"+"</a> ";
                     st = st+".. ";
                 }
                 if (page < d) {
                     d = d-5;
                 }
                 if (page > 10) {
                     st=st+"<a href='"+fileName;
                     st=st+PrintPageNum(d);
                     st=st+".xml'><<<</a> ";
                 }
                 for (i = d; i <= d+9 && i <= pageCount; i++) {
                      if (i != page) {
                          st=st+"<a href='"+fileName;
                          st=st+PrintPageNum(i);
                          st=st+".xml'>"+i+"</a> ";
                      } else
                          st=st+"<b>"+page+"</b> ";
                 }
                 if (i < pageCount) {
                     st=st+"<a href='"+fileName;
                     st=st+PrintPageNum(i-1);
                     st=st+".xml'>>>></a> ";
                     st=st+".. ";
                     st=st+"<a href='"+fileName;
                     st=st+PrintPageNum(pageCount);
                     st=st+".xml'>"+pageCount+"</a> ";
                 }
                 document.getElementById("Navig").innerHTML = st;
            }
        }

        function checkParent( src, tagName ) {
                while (src != null) {
                    if (src.tagName == tagName)
                        return src;
                    src = src.parentNode;
                }
                return null;
        }

        function checkContent( src, tagName ) {
	
                if (src != null) {
                    for (i=0; i<src.childNodes.length; i++)
                        if (src.childNodes[i].tagName == tagName)
                            return src.childNodes[i];
                }
                return null;
        }


        function Change(item){
                if (item != null) {
                   if (item.value == "-")
                       item.value = "+";
                   else
                       item.value = "-";
                }
        }

        function OpenClose(src)
        {
                var item = checkParent( src, "LI" ) ;
                if (item != null)
                {
                        var input = checkContent( item, "INPUT" ) ;
                        Change(input);
                        var content = checkContent( item, "UL" ) ;
                        if (content != null)
                            if (content.style.display == "")
                                content.style.display = "block" ;
                            else
                                content.style.display = "" ;
                }
                event.cancelBubble = true;
        }

        function OpenCloseDiv(src)
        {        
                var elem = src.nextSibling;
                if(typeof elem.style == "undefined")
		{
			elem = elem.nextSibling;
		}

                var style = elem.style.display;
                if ((style == "") || (style == "none"))
                    elem.style.display = "block";
                else
                    elem.style.display = "none";

                var tmp = src.childNodes[0]; // TABLE
                tmp = tmp.childNodes[0];     // TBODY
                tmp = tmp.childNodes[0];     // TR
                var tmp1 = tmp;
                tmp = tmp.childNodes[2];     // Third TD
                tmp = tmp.childNodes[1];     // INPUT
                if(typeof tmp == "undefined")
                {
			
	            Change(tmp1.childNodes[5].childNodes[3]);
                }
		else
		{
	            Change(tmp);                 // "+" <-> "-"
		}

        }

        function OpenCloseAll (src,what_to_do)
        {
                var pos = 0;
                var elem;
                var coll = document.getElementsByTagName("UL");
                var len = coll.length;
                while (pos < len) {
                        elem = coll[pos];
                        pos++;
                        if ((elem.style.display == "") && (what_to_do == "open"))
                             elem.style.display = "block";
                        else if ((elem.style.display == "block") && (what_to_do == "close"))
                             elem.style.display = "";
                }

                pos = 0;
                coll = document.getElementsByTagName("DIV");
                len = coll.length;
                while (pos < len) {
                        elem = coll[pos];
                        pos++;
                        if ((elem.style.display == "none") && (what_to_do == "open"))
                             elem.style.display = "block";
                        else if ((elem.style.display == "block") && (what_to_do == "close"))
                             elem.style.display = "none";
                }

                pos = 0;
                coll = document.getElementsByTagName("INPUT");
                len = coll.length;
                while ( pos<len  ) {
                        elem = coll[pos];
                        pos++;
                        if ( ((elem.value=="+")&&(what_to_do=="open")) || ((elem.value=="-")&&(what_to_do=="close")) )
                                   Change(elem);
                }
       }
       function SetTableWidths() {
                if (document.all)
                {
                    var coll = document.getElementsByTagName("TABLE");
                    var len = coll.length;
                    var elem;
                    var pos = 0;
                    while (pos < len)
                    {
                        elem = coll[pos];
                        pos++;
                        if (elem.className == "UpTable")
                            elem.style.width = "91%";
                    }
                }
       }
]]>
</script>
</head>

<body>
<xsl:attribute name="onLoad">
    <xsl:text>Links('</xsl:text><xsl:value-of select="Navigate/@fileName"/>
    <xsl:text>','</xsl:text><xsl:value-of select="Navigate/@page"/><xsl:text>','</xsl:text><xsl:value-of select="Navigate/@pageCount"/>
    <xsl:text>');SetTableWidths();</xsl:text><!--SetTableWidths();-->
</xsl:attribute>
<div align="right">
    <input class="inputNorm" type="submit" onClick="OpenCloseAll(document.getElementById('MainDiv'), 'open');" value="Open All"/>
    <xsl:text>  </xsl:text>
    <input class="inputNorm"  type="submit" onClick="OpenCloseAll(document.getElementById('MainDiv'),'close');" value="Close All"/>
</div>
<div align="Center" id="Navig">
</div>
<div id="MainDiv">
   <ul><xsl:call-template name="all"/></ul>
</div>

</body>
</html>
</xsl:template>


<xsl:template match="Call">
    <li class="oParent">
        <xsl:if test="position() mod 2 = 0"><xsl:attribute name="class">MessageDark</xsl:attribute></xsl:if>
        <xsl:if test="Message!=''">
            <input class="CallLight" type="submit" onClick="OpenClose(this);" value="-" /><xsl:text> </xsl:text>
        </xsl:if>
        <span class="CallStart" onClick="OpenClose(this);">
            <span onMouseOver="this.className='Over'" onMouseOut="this.className=''">
                <xsl:value-of select="CallStart"/>
            </span>
        </span>
        <ul style="display: block">
            <xsl:for-each select="Message">
                <xsl:apply-templates select="."/>
            </xsl:for-each>
            <xsl:if test="Message!=''">
                    <xsl:if test="CallStop=''">
                        <li class="cItem"><span class="CallStop"></span></li>
                    </xsl:if>
            </xsl:if>
            <xsl:if test="CallStop!=''">
                <li class="cItem"><span class="CallStop"><xsl:value-of select="CallStop"/></span></li>
            </xsl:if>
        </ul>
    </li>
</xsl:template>

<xsl:template match="Message">
    <li class="MessageLight">
            <xsl:if test="position() mod 2 = 0">
                <xsl:attribute name="class">MessageDark</xsl:attribute>
            </xsl:if>

        <xsl:if test="MsgBody!='' or MsgHex!=''">
            <input class="MessageLight" type="submit" value="+" onClick="OpenClose(this);">
                    <xsl:if test="position() mod 2 = 0">
                        <xsl:attribute name="class">MessageDark</xsl:attribute>
                          </xsl:if>
            </input>
            <xsl:text> </xsl:text>
        </xsl:if>
        <span onClick="OpenClose(this);">
            <xsl:attribute name="class">
            <xsl:choose>
                <xsl:when test="@type!='RegSign'">
                <xsl:variable name="class" select="concat(@type,@line,@port)"/>
                <xsl:choose>
                    <xsl:when test="$class=''">
                        <xsl:text>rx2</xsl:text>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="$class"/>
                    </xsl:otherwise>
                </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                <xsl:variable name="classRS" select="concat(@line,@port)"/>
                    <xsl:choose>
                        <xsl:when test="$classRS=''">
                            <xsl:text>RSrx2</xsl:text>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of select="concat('RS',$classRS)"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
            </xsl:attribute>
            <xsl:choose>
                <xsl:when test="MsgBody!='' or MsgHex!=''">
                    <span onMouseOver="this.className='Over'" onMouseOut="this.className=''">
                        <xsl:choose><xsl:when test="@discrepancy = 1"><strong style="color:red;">!</strong></xsl:when><xsl:otherwise><xsl:text>&#160;</xsl:text></xsl:otherwise></xsl:choose> <xsl:value-of select="translate(concat(substring('       ', string-length(@number) + 1), @number), ' ', '&#160;')"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="@date"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="@time_abs"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="@time_rel"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="translate(concat(substring('              ', string-length(@interval) + 1), @interval), ' ', '&#160;')"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="MsgHdr"/>
                    </span>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="translate(concat(substring('       ', string-length(@number) + 1), @number), ' ', '&#160;')"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="@date"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="@time_abs"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="@time_rel"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="translate(concat(substring('              ', string-length(@interval) + 1), @interval), ' ', '&#160;')"/> <xsl:text>&#160;</xsl:text> <xsl:value-of select="MsgHdr"/>
                </xsl:otherwise>
            </xsl:choose>
        </span>
        <xsl:if test="MsgBody!='' or MsgHex!=''">
            <ul class="MsgBody">
                <li class="MsgBody"><pre class="MsgHex"><xsl:value-of select="MsgHex"/></pre>
                <xsl:for-each select="Element">
                   <pre class="MsgHex">
                     <xsl:if test="@discrepancy = 1 or @semi-discrepancy = 1">
                        <xsl:attribute name="style">color:red;</xsl:attribute>
                     </xsl:if>
                     <xsl:value-of select="@name"/>
                   </pre>
                </xsl:for-each>
                <table border="0" cellpadding="0" cellspacing="0" width="100%" class="UpTable"><!-- onmousemove="if (document.all) this.width='91%'"-->
                   <tr><td>
                       <table border="0" cellspacing="1" cellpadding="0" width="100%"><tr>
                           <th width="81px">POS<div width="81px" height="1px" /></th>
                           <th width="80px">BINARY<div width="80px" height="1px" /></th>
                           <th width="341px">NAME<div width="341px" height="1px" /></th>
                           <th>VALUE</th>
                       </tr></table>
                   </td></tr>
                </table>
                <xsl:apply-templates select="MsgBody/Element"/></li>
            </ul>
        </xsl:if>
    </li>
</xsl:template>

<xsl:template match="MsgBody/Element">
    <xsl:call-template name="ElementsTree">
        <xsl:with-param name="level">0</xsl:with-param>
    </xsl:call-template>
</xsl:template>

<xsl:template name="ElementsTree">
    <xsl:param name="level"/>
    <div onClick="OpenCloseDiv(this);">
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
            <xsl:if test="$level=0">
                <xsl:attribute name="class">UpTable</xsl:attribute>
            </xsl:if>
            <tr>
                <td class="Light" width="81px"><pre><xsl:value-of select="@pos"/></pre></td>
                <td class="Light" width="80px"><xsl:value-of select="@bits"/></td>
            <td class="LayerInput" align="Right">
                <xsl:attribute name="width">
                     <xsl:value-of select="$level*12+20"/><xsl:text>px</xsl:text>
                </xsl:attribute>
                <div>
                    <xsl:attribute name="width">
                         <xsl:value-of select="$level*12+20"/><xsl:text>px</xsl:text>
                    </xsl:attribute>
                </div>
                <input type="submit" value="+" class="MessageLight"/>
            </td>
            <td class="Name" width="315px">
                 <xsl:attribute name="width">
                     <xsl:value-of select="315-$level*12+5"/><xsl:text>px</xsl:text>
                 </xsl:attribute>
                <span class="Layer">
       	            <span onMouseOver="this.className='Over'" onMouseOut="this.className=''">
               	        <xsl:value-of select="@name"/>
                    </span>
                </span>
            </td>
            <td class="Value"><xsl:value-of select="@value"/><span style="color:#F0F0FF;">.</span></td>
            </tr>
        </table>
    </div><div style="display: none;">
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
            <xsl:if test="$level=0">
                <xsl:attribute name="class">UpTable</xsl:attribute>
            </xsl:if>
            <xsl:for-each select="Element">
                <tr><td>
                <xsl:choose>
                    <xsl:when test="count(child::node()) = 0">

                        <table border="0" cellspacing="0" cellpadding="0" width="100%">
                            <tr>
                            <td class="Light" width="81px"><pre><xsl:value-of select="@pos"/></pre></td>
                            <td class="Light" width="80px"><xsl:value-of select="@bits"/></td>
                            <td class="LayerInput">
                                <xsl:attribute name="style">
                                   <xsl:if test="position()=last()">
                                       border-bottom-style: solid;
                                       border-bottom-width: 1px;
                                       border-bottom-color: silver;
                                   </xsl:if>
                                </xsl:attribute>
                                <xsl:attribute name="width">
                                     <xsl:value-of select="$level*12+17+15"/><xsl:text>px</xsl:text>
                                </xsl:attribute>
                                <div style="color:white;">
                                    <xsl:attribute name="width">
                                         <xsl:value-of select="$level*12+17+15"/><xsl:text>px</xsl:text>
                                    </xsl:attribute>.
                                </div>
                            </td>
                            <td class="Name" width="315px">
                                <xsl:attribute name="width">
                                    <xsl:value-of select="315-$level*12-7"/><xsl:text>px</xsl:text>
                                </xsl:attribute>
                                <xsl:if test="@discrepancy = 1 or @semi-discrepancy = 1">
                                  <xsl:attribute name="style">color:red;</xsl:attribute>
                                </xsl:if>
                                <xsl:value-of select="@name"/>
                            </td>
                            <td class="Value"><xsl:value-of select="@value"/><span style="color:#F0F0FF;">.</span></td>
                            </tr>
                        </table>

                    </xsl:when>
                    <xsl:otherwise>

                        <xsl:choose>
                            <xsl:when test="@name!='' and count(child::node()) &gt; 0">
                                <xsl:call-template name="ElementsTree">
                                    <xsl:with-param name="level"><xsl:value-of select="$level+1"/></xsl:with-param>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%">
                                    <tr>
                                    <td class="Light" width="81px"><pre><xsl:value-of select="@pos"/></pre></td>
                                    <td class="Light" width="80px"><xsl:value-of select="@bits"/></td>
                                    <td class="LayerInput">
                                        <xsl:attribute name="style">
                                           <xsl:if test="position()=last()">
                                               border-bottom-style: solid;
                                               border-bottom-width: 1px;
                                               border-bottom-color: silver;
                                           </xsl:if>                   
                                        </xsl:attribute>
                                        <xsl:attribute name="width">
                                            <xsl:value-of select="$level*12+17+15"/><xsl:text>px</xsl:text>
                                        </xsl:attribute>
                                        <div style="color:white;">
                                            <xsl:attribute name="width">
                                                 <xsl:value-of select="$level*12+17+15"/><xsl:text>px</xsl:text>
                                            </xsl:attribute>.
                                        </div>
                                    </td>
                                    <td class="Name"><xsl:value-of select="@name"/><xsl:value-of select="node()"/><br/></td>
                                    </tr>
                                </table>
                            </xsl:otherwise>
                        </xsl:choose>

                    </xsl:otherwise>
                </xsl:choose>
                </td></tr>
            </xsl:for-each>
        </table>
    </div>
</xsl:template>

<xsl:template match="CallStart">
    <li class="cItem">
            <xsl:if test="position() mod 2 = 0">
                <xsl:attribute name="class">cItemDark</xsl:attribute>
            </xsl:if>
<span class="CallStart"><xsl:value-of select="node()"/></span></li>
</xsl:template>

<xsl:template match="CallStop">
    <li class="cItem">
            <xsl:if test="position() mod 2 = 0">
                <xsl:attribute name="class">cItemDark</xsl:attribute>
            </xsl:if>
<span class="CallStop"><xsl:value-of select="node()"/></span></li>
</xsl:template>

<xsl:template name="all">
    <xsl:apply-templates select="*"/>
</xsl:template>

</xsl:stylesheet>